!MAIN
use dflib
character*80 myfile
character*10 numformat
logical endrec
integer j,recnum,iw
integer nt
real*4 tfitted(270),td(270)
include 'declar.inc'
			CALL SEED(1995)
!open(1,file='my.enx',status='old')
write(*,*) 'Create a simplified output for levdens and plotting cumulative level numbers (1)'
write(*,*) 'Create an complete intermediate file for testing and formatting (2)'
read(*,*) typeofoutput
write(*,*) typeofoutput
open(1,file='my.enx',status='old')
open(2,file='error.txt')
open(3,file='dls.dat',status='unknown')
open(4,file='symbols.txt',status='unknown')
open(9,file='par30_20_-4_4.dat ',status='old')
open(7,file='tvalues.txt ',status='old')
open(8,file='level-param.dat',status='unknown')
open(20,file='completeness.dat',status='unknown')
write(8,'(a)') '#Constant Temperature fit results; RIPL II discrete level segment; November 2001 by T. Belgya '
write(8,'(a)') '#  Z   A El         T        dT        U0       dU0NlevNmax  N0  Nc     Emax       Ec     Chi Fit Flag NoX  Xm  EX   sigma'
write(8,'(a)') '#               [MeV]     [MeV]     [MeV]     [MeV]                    [MeV]    [MeV]                         [MeV]       '
write(8,'(a)') '#-------------------------------------------------------------------------------------------------------------------------'
!if(typeofoutput.eq.2) then 
call readparams(parm,nparm)
call readtemp(tfitted,td,nt)
write(*,*) 'No of paramerters=',nparm
!end if
1 read(1,'(a80)',end=2) myrec
!write(2,'(a80)') myrec
recnum=recnum+1
!write(2,*) recnum
if(.not.endrec(myrec)) then
!write(*,*) nt
call anal(myrec,anuc,parm,nparm,tfitted,td,nt)
if(anuc%a.eq.1.and.anuc%z.eq.7) anuc%z=0
end if
goto 1
2 continue
if(anuc%a.gt.0.and.anuc%nlev.gt.0) then
call outanuc(anuc,parm,nparm,tfitted,td,nt)
endif
close(3)
close(1)
!write(*,*) recnum,nucnum,levnum,gamnum,'Hit return'
!read(*,*)
stop
end
!********************************************
!Identify the record
subroutine anal(myrec,anuc,parm,nparm,tfitted,td,nt)
!character*80 myrec
include 'declar.inc'
!write(2,*) myrec
if(isident(myrec)) then ; call myident(myrec,anuc,parm,nparm,tfitted,td,nt)
else if(isstat(myrec)) then 
!;write(2,*) 'isstat';
 call mystat(myrec,anuc)
else if(islevel(myrec)) then 
!;write(2,*) 'mylevel';
 call mylevel(myrec,anuc)
else if(isgamma(myrec)) then 
!;write(2,*) 'mygamma';
 call mygamma(myrec,anuc)
else if(isq(myrec)) then 
!;write(2,*) 'myq';
 call myq(myrec,anuc)
else if(isnormalization(myrec)) then 
!;write(2,*) 'mynorm';
 call mynormalization(myrec,anuc)
else if(isxref(myrec)) then 
!;write(2,*) 'imyxref';
 call myxref(myrec,anuc); anuc%nxref=nxref
else if(islevelxref(myrec)) then
!;write(2,*) 'mylevxref' ;
 call mylevelxref(myrec,anuc)
else if(isleveldmode(myrec)) then
!;write(2,*) 'mylevxref' ;
iw=scan(myrec,'%')
if(iw.ne.0) then
! write(4,*) myrec
endif
 call mydmode(myrec,anuc)
else if(isband(myrec)) then
! write(4,*) myrec
call myband(myrec,anuc)
else
end if
!write(2,*) nucnum,levnum,gamnum,nxref
return
end
!********************************************
!Decode particle record
subroutine mynormalization(myrec,anuc)
include 'declar.inc'
!write(*,'(2i4,a80)') anuc%a,anuc%z,myrec
end

!********************************************
!Print output
subroutine outanuc(anuc,parm,nparm,tfitted,td,nt)
integer i,j,gamcount,k,m
integer itwo,ifour,init,final
integer nt
real*4 tfitted(270),td(270),eave
character*2 el,symb*5
logical flag,even
include 'declar.inc'
gamcount=0
if(anuc%a.eq.0.and.anuc%z.eq.0.or.anuc%nlev.le.0) goto 11
write(*,'(4i4)') anuc%A,anuc%Z,anuc%nlev,anuc%nxref
j=0
if(typeofoutput.eq.2) then
call spinestimate(anuc,parm,nparm,tfitted,td,nt)
!NEW FORMAT
call ZNAME(EL,anuc%Z,2)
if(anuc%z.eq.0) el='n '
write(symb,'(i3,a2)') anuc%A,el
eave=0.
write(3,'(a5,6i5,2f12.3)') &
		symb, &
		anuc%A, &
		anuc%Z, &
		anuc%nlev, &
		anuc%ngam, &
		anuc%nmax, &
		anuc%nc, &
		anuc%sn, &
		anuc%sp
do i=1,anuc%nlev
if(i.le.anuc%nmax) eave=eave+anuc%mylev(i)%e
	write(3,'(i3,1x,1pe12.5,1x,0pf5.1,f4.0,1p(1x,e10.3),i3,1x,a1,1x,a4,1x,a18,i3,10(1x,a2,1x,1pe9.2,1x,a7))') &
		i, &
		anuc%mylev(i)%e, &
		anuc%mylev(i)%jsmy, &
		anuc%mylev(i)%jpmy, &
		anuc%mylev(i)%t, &
		anuc%mylev(i)%nog, &
		anuc%mylev(i)%jpestimate, &
		anuc%mylev(i)%uncertain, &
		anuc%mylev(i)%jptext, &
		anuc%mylev(i)%nobr, &
		(anuc%mylev(i)%pfix(m),anuc%mylev(i)%dpercent(m),anuc%mylev(i)%dmodes(m),m=1,anuc%mylev(i)%nobr)
		do k=1,anuc%mylev(i)%nog
			j=j+1
			write(3,'(2i4,1pe12.5,1x,e9.2,1x,e9.2,1x,e10.3,1x,a10)') &
			anuc%mygam(j)%initial, &
			anuc%mygam(j)%final, &
			anuc%mygam(j)%e, &
			anuc%mygam(j)%ri, &
			anuc%mygam(j)%cc, &
			anuc%mygam(j)%mr(1), &
			anuc%mygam(j)%mult

		enddo
enddo
if(anuc%nmax.gt.0) then
eave=eave/anuc%nmax
write(20,'(2i5,1x,6(1pe12.5,1x),i3,1x,a1,1x,a1)') anuc%A,anuc%z,eave*0.001,anuc%mylev(anuc%nmax)%e*0.001,eave*0.001-anuc%mylev(anuc%nmax)%e*0.001,tfitted(anuc%a),td(anuc%a),sqrt(anuc%spcutoff2),anuc%ncrelaxed,even(anuc%a),even(anuc%z)
else
eave=0.
write(20,'(2i5,1x,6(1pe12.5,1x),i3,1x,a1,1x,a1)') anuc%A,anuc%z,eave*0.001,0.,0.,tfitted(anuc%a),td(anuc%a),sqrt(anuc%spcutoff2),anuc%ncrelaxed,even(anuc%a),even(anuc%z)
endif
1 write(3,*) '_____________________________________________'
elseif(typeofoutput.eq.1) then
call spinestimate(anuc,parm,nparm,tfitted,td,nt)

write(3,'(4i4)') anuc%A,anuc%Z,anuc%nlev,anuc%nxref
do i=1,anuc%nlev
	write(3,'(e13.6,1x,i4)') &
		anuc%mylev(i)%e, i 
enddo
end if

!do i=1,anuc%nlev
!write(4,'(i4,6f6.1,1x,a1)') i,anuc%mylev(i)%js,anuc%mylev(i)%jsmy,anuc%mylev(i)%jpestimate
!enddo
!do j=1,anuc%nxref
!write(3,'(a80)') anuc%xreflines(j)
!write(4,'(a80)') anuc%xreflines(j)
!enddo
!write(*,*) anuc%A,anuc%Z
!do i=1,anuc%nlev
!write(3,'(e13.6,1x,i4,1x,a4)') anuc%mylev(i)%e,i,anuc%mylev(i)%uncertain
!gamcount=gamcount+anuc%mylev(i)%nog
!do j=gamcount-anuc%mylev(i)%nog+1,gamcount
!if(j.ne.0) then
!write(3,'(i4,(1x,e13.6,1x,e10.3),4(1x,f7.3))') anuc%mygam(j)%final,anuc%mygam(j)%e,anuc%mygam(j)%de, &
!anuc%mygam(j)%cc,anuc%mygam(j)%dcc,anuc%mygam(j)%ti,dti
!endif
!write(3,'(a80)') anuc%mylev(i)%inprow
!write(3,'(e13.6,1x,e9.2,1x,a4,2(1x,e9.2),i2,5(2f5.1,i2),1x,a18,a40)') anuc%mylev(i)%e,anuc%mylev(i)%de, &
!anuc%mylev(i)%t,anuc%mylev(i)%dt,anuc%mylev(i)%nospin, &
!(anuc%mylev(i)%js(j),anuc%mylev(i)%jp(j),anuc%mylev(i)%jmodi(j),j=1,5),anuc%mylev(i)%jptext, &
!anuc%mylev(i)%xrefs
!write(3,'(4i5,1p4(1x,e13.6,1x,e10.3))')anuc%A,anuc%Z,anuc%nlev,anuc%ngam,anuc.q, &
!anuc.dq,anuc.sn,anuc.dsn,anuc.sp,anuc.dsp,anuc.qa,anuc.dqa
!if(anuc%A.eq.89.and.anuc%Z.eq.41) then
!j=0
!endif
!goto 1
!do i=1,anuc%nlev
!	write(3,'(1pe12.5,1x,e8.1,0pf5.1,f4.0,1p2(1x,e10.3),i3,1x,a1,1x,a4,1x,a18)') anuc%mylev(i)%e,anuc%mylev(i)%de, &
!	anuc%mylev(i)%jsmy,anuc%mylev(i)%jpmy,anuc%mylev(i)%t,anuc%mylev(i)%dt,anuc%mylev(i)%nog, &
!	anuc%mylev(i)%jpestimate,anuc%mylev(i)%uncertain,anuc%mylev(i)%jptext
!	do k=1,anuc%mylev(i)%nog
!		j=j+1
!		write(3,'(2i4,1pe12.5,1x,e8.1,1x,e10.3,1x,e9.2,1x,e9.2,1x,e8.1,1x,e8.1,2(1x,e9.2,1x,e8.1),2i2,a3,4a1)') &
!		anuc%mygam(j)%initial,anuc%mygam(j)%final,anuc%mygam(j)%e,anuc%mygam(j)%de, &
!		anuc%mygam(j)%ri,anuc%mygam(j)%dri, &
!		(anuc%mygam(j)%mr(m),m=1,3),anuc%mygam(j)%cc,anuc%mygam(j)%dcc, &
!		anuc%mygam(j)%ti,anuc%mygam(j)%dti,anuc%mygam(j)%ml(1),anuc%mygam(j)%ml(2), &
!		anuc%mygam(j)%mlmod,anuc%mygam(j)%multplace,anuc%mygam(j)%coinc,anuc%mygam(j)%uncertain,anuc%mygam(j)%parity
!	enddo
!enddo
11 return
end
subroutine readtemp(tfitted,td,nt)
integer ia
real*4 tfitted(270),td(270)
real*4 tw,dtw
nt=0
read(7,*)
do while(.not.eof(7))
nt=nt+1
read(7,*) ia,tw,dtw
tfitted(ia)=tw
td(ia)=dtw
enddo
end
