!********************************************
!Decode gamma record
subroutine mygamma(myrec,anuc)
character*10 numformat,unit
character mx*3,nx*2
real*8 x(3)
include 'declar.inc'

gamnum=gamnum+1
!write(2,*) gamnum
anuc%mylev(levnum)%nog=anuc%mylev(levnum)%nog+1
call fend(myrec(10:19),myrec(20:21),x,mx,nx)
anuc%mygam(gamnum)%e=x(1)
anuc%mygam(gamnum)%de=x(2)
call fend(myrec(22:29),myrec(30:31),x,mx,nx)
anuc%mygam(gamnum)%ri=x(1)
anuc%mygam(gamnum)%dri=x(2)
if(nx.eq.'LT') then
anuc%mygam(gamnum)%ri=0.0
anuc%mygam(gamnum)%dri=x(1)
endif
anuc%mygam(gamnum)%mult=myrec(32:41)
call GetML(myrec(32:41),anuc%mygam(gamnum)%ml,anuc%mygam(gamnum)%parity,anuc%mygam(gamnum)%mlmod)
!c  Decode ENSDF data into numeric data -> Multipol mixing ratio
!c  Array x returns value and asymmetric uncertainties
!c  String NX returns non-numerical uncertainty
!c  String MX returns '  ?' or ' ()'
!c  String UNIT returns valid unit
call fendU(myrec(42:49),myrec(50:55),x,mx,nx,unit)
anuc%mygam(gamnum)%mr(1)=x(1)
anuc%mygam(gamnum)%mr(2)=x(2)
anuc%mygam(gamnum)%mr(3)=x(3)
call fend(myrec(56:62),myrec(63:64),x,mx,nx)
anuc%mygam(gamnum)%cc=x(1)
anuc%mygam(gamnum)%dcc=x(2)
call fend(myrec(65:74),myrec(75:76),x,mx,nx)
anuc%mygam(gamnum)%ti=x(1)
anuc%mygam(gamnum)%dti=x(2)
anuc%mygam(gamnum)%multplace=myrec(77:77)
anuc%mygam(gamnum)%coinc=myrec(78:78)
anuc%mygam(gamnum)%uncertain=myrec(80:80)
anuc%mygam(gamnum)%final=lcode(myrec(4:5))
anuc%mygam(gamnum)%initial=levnum
!if(anuc%mygam(gamnum)%final.ne.lcode(myrec(4:5))) then
!write(3,'(2i4,1pe12.5)') anuc%mygam(gamnum)%initial,anuc%mygam(gamnum)%final,anuc%mygam(gamnum)%e
!read(*,*)
!endif
end
!********************************************
!decode level #
integer function lcode(text)
character*2 text
integer itext(2)
text=adjustr(text)
if(verify(text,'+-0123456789 ').eq.0) then
	read(text,'(i2)') lcode
else
	lcode=99
	itext(1)=ichar(text(1:1))
	itext(2)=ichar(text(2:2))
! Capital letter
	if(itext(2).ge.65.and.itext(2).le.90) then
		if(itext(1).eq.32) then
		itext(2)=itext(2)-64
		lcode=lcode+itext(2)
		else
		itext(2)=itext(2)-64
		itext(1)=itext(1)-47
		lcode=lcode+itext(1)*52+itext(2)
		end if
	else 
		if(itext(2).ge.97.and.itext(2).le.122) then
			if(itext(1).eq.32) then
			itext(2)=itext(2)-96+26
			lcode=lcode+itext(2)
			else
			itext(2)=itext(2)-96+26
			itext(1)=itext(1)-47
			lcode=lcode+itext(1)*52+itext(2)
			end if
		else
			write(*,*) 'Error in decode level #',itext(2)
		end if
	end if
end if
end
!********************************************
subroutine myq(myrec,anuc)
character mx*3,nx*2
real*8 x(3)
include 'declar.inc'
call fend(myrec(10:19),myrec(20:21),x,mx,nx)
anuc.q=x(1);anuc.dq=x(2)
call fend(myrec(22:29),myrec(30:31),x,mx,nx)
anuc.sn=x(1);anuc.dsn=x(2)
call fend(myrec(32:39),myrec(40:41),x,mx,nx)
anuc.sp=x(1);anuc.dsp=x(2)
call fend(myrec(42:49),myrec(50:55),x,mx,nx)
anuc.qa=x(1);anuc.dqa=x(2)

end
!********************************************
!fraction of a real number
real function frac(x)
real x
frac=x-aint(x)
if(frac.le.2.e-6) frac=0.
if(frac.ge.0.999999) frac=0.
end
!********************************************
subroutine mystat(myrec,anuc)
include 'declar.inc'
read(myrec(1:3),'(i3)') anuc%A
read(myrec(4:6),'(i3)') anuc%Z
read(myrec(11:14),'(i4)') anuc%nlev
read(myrec(21:24),'(i4)') anuc%ngam
if(mod(anuc%A,2).eq.0) then
anuc%evenodd=0.0
else
anuc%evenodd=0.5
endif
end
!********************************************
! Determine whether myrec is end of record
logical function endrec(myrec)
character*80 myrec
integer i
endrec=.TRUE.
do i=1,80
if(myrec(i:i).ne.' ') endrec=.FALSE.
end do
return
end
!********************************************
!functions for identifying a card
logical function isident(myrec)
character*80 myrec
isident=.FALSE.
if(myrec(9:9).eq.'*') isident=.TRUE.
end
!********************************************
!functions for identifying a card
logical function isband(myrec)
character myrec*80
isband=.FALSE.
if(myrec(7:8).eq.'CL') then
do i=8,15
if(myrec(i:i+4).eq.'BAND(') then
  isband=.TRUE.;goto 1
endif
enddo
1 continue
endif
end
!********************************************
subroutine myband(myrec,anuc)
include 'declar.inc'
anuc%nobands=anuc%nobands+1
anuc%bands(anuc%nobands)=myrec(3:3)
anuc%sdbands(anuc%nobands)='n'
do i=8,75
if(myrec(i:i+1).eq.'SD') then
  anuc%sdbands(anuc%nobands)='y';goto 1
endif
enddo
1 continue
end
!********************************************
logical function isstat(myrec)
character*80 myrec
isstat=.FALSE.
if(myrec(8:8).eq.'I') isstat=.TRUE.
end
!********************************************
logical function islevel(myrec)
character*80 myrec
islevel=.FALSE.
if(myrec(8:8).eq.'L'.and.myrec(6:7).eq.'  ') islevel=.TRUE.
end
!********************************************
logical function isxref(myrec)
character*80 myrec
isxref=.FALSE.
if(myrec(8:8).eq.'X') isxref=.TRUE.
end
!********************************************
logical function islevelxref(myrec)
character*80 myrec
islevelxref=.FALSE.
!if(myrec(8:8).eq.'L'.and.(myrec(6:6).eq.'X'.or.verify(myrec,' XREF=').ne.0)) islevelxref=.TRUE.
end
!********************************************
logical function isgamma(myrec)
character*80 myrec
isgamma=.FALSE.
if(myrec(8:8).eq.'G'.and.myrec(6:7).eq.'  '.and.myrec(5:5).ne.' ') isgamma=.TRUE.
end
!********************************************
logical function isq(myrec)
character*80 myrec
isq=.FALSE.
if(myrec(8:8).eq.'Q'.and.myrec(6:7).eq.'  ') isq=.TRUE.
end
!********************************************
logical function isnormalization(myrec)
character*80 myrec
isnormalization=.FALSE.
if(myrec(8:8).eq.'N'.and.myrec(6:7).eq.'  ') isnormalization=.TRUE.
end
!********************************************
logical function isleveldmode(myrec)
character*80 myrec
isleveldmode=.FALSE.
if(myrec(8:8).eq.'L'.and.myrec(6:6).eq.'2'.and.myrec(7:7).ne.'c'.and.index(myrec(8:80),'%').ne.0) isleveldmode=.TRUE.
end
!********************************************
!Parseing identification cards
subroutine myident(myrec,anuc,parm,nparm,tfitted,td,nt)
integer dbug,nt
real*4 tfitted(270),td(270)
include 'declar.inc'
!write(*,*) 'In myident'
if(nucnum.gt.1) then
if(gamnum.ne.anuc%ngam) then
write(*,*) 'error in # of gammas nuc.',anuc%A,anuc%Z,gamnum,anuc%ngam
if(gamnum.gt.anuc%ngam) anuc%ngam=gamnum
end if
if(levnum.ne.anuc%nlev) write(*,*) 'error in number of levels in nucleus',anuc%A,anuc%Z
end if
!write(*,*) 'Enter to output'
call outanuc(anuc,parm,nparm,tfitted,td,nt)
!write(*,*) 'End of myident'
nucnum=nucnum+1; gamnum=0;levnum=0;nxref=0
call anucinit(anuc)
anuc%nucid=myrec(1:5)
anuc%ref=myrec(10:80)
end
!********************************************
subroutine anucinit(anuc)
integer i,k
include 'declar.inc'
!initalize anuc
anuc%a=0;anuc%z=0;anuc%nlev=0;anuc%ngam=0;anuc%nxref=0;anuc%nmax=0;anuc%nc=0;anuc%nobands=0;anuc%nouncertain=0
anuc%q=0.0;anuc%dq=0.0;anuc%qa=0.0;anuc%dqa=0.0;anuc%sn=0.0;anuc%dsn=0.0;anuc%sp=0.0;anuc%dsp=0.0;anuc%emin=1.0e10
anuc%evenodd=-1.0;anuc%spcutoff2=0.0
anuc%umax=0.0
anuc%uc=0.0
anuc%unclevnum='    '
anuc%unceremin='       '
anuc%nucid='     '
anuc%ref='                                                                         '
anuc%chi=0.0;anuc%umax=0.0;anuc%uc=0.0;anuc%u0=0.0;anuc%du0=0.0
do i=1,40
anuc%bands(i)=' '
anuc%sdbands(i)=' '
enddo
do i=1,50
anuc%xreflines(i)='                                                                                '
enddo
!initalize anuc%mylev
do i=1,600
	anuc%mylev(i)%nospin=0;anuc%mylev(i)%nog=0;anuc%mylev(i)%band=' ';anuc%mylev(i)%sdband=' '
	do k=1,5
	anuc%mylev(i)%jmodi(k)=0;anuc%mylev(i)%js(k)=-1.0;anuc%mylev(i)%jp(k)=0.0
	enddo
	anuc%mylev(i)%e=0.0;anuc%mylev(i)%de=0.0;anuc%mylev(i)%t=0.0;anuc%mylev(i)%dt=0.0
	anuc%mylev(i)%jsmy=-1.0;anuc%mylev(i)%jpmy=-1.0
	anuc%mylev(i)%metastable='  ';anuc%mylev(i)%uncertain='    '
	anuc%mylev(i)%inprow='                                                                                '
	anuc%mylev(i)%jptext='                  '
	anuc%mylev(i)%xrefs='                                                            '
	anuc%mylev(i)%jpestimate=' '
	anuc%mylev(i)%nobr=0
	do k=1,10
	anuc%mylev(i)%dmodes(k)='       '
	anuc%mylev(i)%pfix(k)='  '
	anuc%mylev(i)%dpercent(k)=0.0
	anuc%mylev(i)%dpercentu(k)=0.0
	enddo
enddo
!initalize anuc%mygam
do i=1,1200
	anuc%mygam(i)%e=-1.0;anuc%mygam(i)%de=-1.0;anuc%mygam(i)%ri=-1.0;anuc%mygam(i)%dri=-1.0;anuc%mygam(i)%cc=-1.0
	anuc%mygam(i)%dcc=-1.0;anuc%mygam(i)%ti=-1.0;anuc%mygam(i)%dti=-1.0
	do k=1,3
	anuc%mygam(i)%mr(k)=0.0
	enddo
	do k=1,2
	anuc%mygam(i)%ml(k)=0
	enddo
	anuc%mygam(i)%initial=0;anuc%mygam(i)%final=600
	anuc%mygam(i)%multplace=' '
	anuc%mygam(i)%coinc=' '
	anuc%mygam(i)%uncertain=' '
	anuc%mygam(i)%parity=' '
	anuc%mygam(i)%mlmod='   '
	anuc%mygam(i)%mult='          '
enddo


end
!********************************************
!decode energy error
real function ecode2(x,numtext,text)
real x
integer expos,exponent,fpoint,sigma,lnumtext,ltext
character numtext*(*),text*(*),form*4,tform*8
lnumtext=len(numtext)
ltext=len(text)
write(tform,'(a2,i1,a1)') '(i',ltext,')'
text=adjustr(text)
numtext=adjustr(numtext)
if(verify(text,'+-0123456789 ').eq.0) then
!number
	read(text,tform) sigma
	if(text.eq.'  ')then
		if(x.eq.0.0)then
		ecode2=0.;return
		else
		ecode2=-1.;return
		endif
	endif
	if(index(numtext,'E').eq.0) then
	!no exponent
		if(index(numtext,'.').eq.0) then
		ecode2=sigma;return
		!no exponent and no floating point
		else
		!no exponent and floating point
		fpoint=index(numtext,'.')
		ecode2=float(sigma)*10.**float(fpoint-lnumtext)
		return
		end if
	else
	!exponent
	expos=index(numtext,'E')
		if(expos.lt.lnumtext) then
		write(form,'(a2,i1,a1)') '(i',lnumtext-expos,')'
		read(numtext(expos+1:lnumtext),form) exponent
		else
		write(*,*) 'wrong exponent:',numtext;return
		endif
		if(index(numtext,'.').eq.0) then
		!exponent and no floating point
		ecode2=float(sigma)*10.0**float(exponent);return
		else
		!exponent and floating point
		fpoint=index(numtext,'.')
		ecode2=float(sigma)*10.0**float(-expos+fpoint+1+exponent);return
		end if

	end if
else
!not number
ecode2=-2.
endif

end
!********************************************
!decode energy
real function ecode1(ch,text)
character ch*(*),text*(*),iform*10,fform*10
integer i,j,temp,lch
logical isE
lch=len(ch)
write(iform,'(a2,i2,a1)') '(i',lch,')'
write(fform,'(a2,i2,a3)') '(f',lch,'.0)'
text='    '
ch=adjustr(ch)
if(verify(ch,'+-0123456789 ').eq.0) then
! integer
read(ch,iform) temp
ecode1=temp
return
else if(verify(ch,'+-0123456789 .eE').eq.0) then
!float
read(ch,fform) ecode1
return
else
isE=.False.
j=0
do i=1,lch
if(verify(ch(i:i),'+-.0123456789 eE').eq.1) then
	j=j+1
	if(j.le.4) then
	text(j:j)=ch(i:i)
	ch(i:i)=' '
	else
	ecode1=-1.
!	write(2,*) 'Sample Energy ',ch
	return
	end if
else
	if(.not.isE.and.ch(i:i).eq.'+') then
		j=j+1
		if(j.le.4) then
		text(j:j)=ch(i:i)
		ch(i:i)=' '
		else
		ecode1=-1.
!		write(2,*) 'Sample Energy ',ch
		return
		end if
	end if

isE=(ch(i:i).eq.'E')
if(isE) then
write(*,*) ch
end if
end if

enddo
ch=adjustr(ch)
if(verify(ch,'+-0123456789 ').eq.0) then
! integer
read(ch,iform) temp
ecode1=temp
return
else if(verify(ch,'+-0123456789 .eE').eq.0) then
!float
read(ch,fform) ecode1
return
end if
endif
end
!********************************************
!decode halflife
real function tcode1(card,dt1)
      implicit DOUBLE PRECISION (a-h,o-z)
character card*(*),unit*3,mx*3,nx*2
real*8 x(3)
real dt1
integer it,itypes
tcode1=0.0;dt1=0.0
if(index(card(40:49),'STABLE').ne.0) then
tcode1=-1.;return
endif
it=itypes(card(50:55))
!C   NULL                    0
!C   NUMERIC (0-9)           1
!C   ALPHA (A-Z OR a-z)      2
!C   BLANK                   3
!C   OTHER                   4
!C   MIXED                  -1
!C   FORTRAN NUMBER         -2
if(it.ne.0) then
call fendu(card(40:49),card(50:55),x,mx,nx,unit)
call un2sec(x,unit,'  ')
tcode1=x(1)
	if(nx.eq.'  ') then
		if(x(2).eq.x(3)) then
		dt1=x(2)
		else
		dt1=dmin1(x(2),x(3))
		endif
	else
		dt1=-1.
	endif
endif
end
!********************************************
!decode spin and parity
subroutine jpdecode(icard,A,js,jp,jmodi,l)
character*18 icard,IC
character*3 mjpi(5)
character*1 ierr,pi(5)
integer j(5),l,A,jmodi(5),i
real js(5),jp(5)
logical tmp
call JREAD(icard,j,pi,mjpi,l,ierr)
if(l.gt.0) then
	tmp=(float(A)/2.-int(A/2).gt.0.4)
!	write(2,*) l,' ',tmp,' ',icard,' ',j,pi
	do i=1,5
	if(tmp.and.j(i).ne.-1.0) then
		js(i)=float(j(i))*.5
	else
		js(i)=float(j(i))
	endif
	if(pi(i).eq.'+') then
		jp(i)=1.
	elseif(pi(i).eq.'-') then
		jp(i)=-1.
	else
		jp(i)=0.
	endif
	if(mjpi(i).eq.'   ') then
		jmodi(i)=0
	elseif(mjpi(i).eq.' (J') then
		jmodi(i)=1
	elseif(mjpi(i).eq.' (P') then
		jmodi(i)=2
	elseif(mjpi(i).eq.' (B') then
		jmodi(i)=3
	elseif(mjpi(i).eq.'  O') then
		jmodi(i)=4
	elseif(mjpi(i).eq.'  A') then
		jmodi(i)=5
	endif
	enddo
endif
!C
!C  Subroutine to read ENSDF JPI field and return array of J and PI values
!C  and alphanumeric modifier.
!C
!Cicard contains input spin field, j(5) and pi(5) are the returned
!Cspin and parity values (up to 5), and l is the number of spins
!Creturned.  J=-1 for a blank spin (e.g. only parity given).
!CThe alphanumeric modifiers for each JPI are as follows:
!C         b(J=spin in parenthesis
!C         b(P=parity in parenthesis
!C         b(B-spin and parity in parenthesis
!Cand
!C         b=blank, or ,(separated by commas) or A (separated by AND)
!C           or O (separated by OR).
!CIf the value is systematic, replace ( by [ in the above definitions.

end
!********************************************
!Decode level record
subroutine mylevel(myrec,anuc)
character numformat*10
integer i
include 'declar.inc'
levnum=levnum+1
!write(2,*) 'levnum=',levnum
anuc%mylev(levnum)%xrefs='                                                  '
if(levnum.ne.lcode(myrec(4:5))) then
write(*,*) 'bad identification of level',levnum,lcode(myrec(4:5))
write(*,*) myrec
read(*,*)
end if
anuc%mylev(levnum)%inprow=myrec
anuc%mylev(levnum)%e=ecode1(myrec(10:19),anuc%mylev(levnum)%uncertain)
if(index(anuc%mylev(levnum)%uncertain,'SP').ne.0) then
anuc%mylev(levnum)%uncertain='    '
anuc%mylev(levnum)%e=anuc%mylev(levnum)%e+anuc%sp
endif
if(index(anuc%mylev(levnum)%uncertain,'SN').ne.0) then
anuc%mylev(levnum)%uncertain='    '
anuc%mylev(levnum)%e=anuc%mylev(levnum)%e+anuc%sn
endif
if(anuc%mylev(levnum)%uncertain.ne.'    ') then
anuc%nouncertain=anuc%nouncertain+1
if(anuc%emin.gt.anuc%mylev(levnum)%e) then
anuc%emin=anuc%mylev(levnum)%e
write(anuc%unclevnum,'(i4)') levnum
endif
if(anuc%emin.lt.1.0e10) then
write(anuc%unceremin,'(1x,f6.3)') anuc%emin*0.001
endif
!write(*,*)	anuc%mylev(levnum)%uncertain,anuc%nouncertain
endif
anuc%mylev(levnum)%de=ecode2(anuc%mylev(levnum)%e,myrec(10:19),myrec(20:21))
read(myrec,'(21x,a18)') anuc%mylev(levnum)%jptext
anuc%mylev(levnum)%jptext=adjustr(anuc%mylev(levnum)%jptext)
anuc%mylev(levnum)%t=tcode1(myrec,dt1)
anuc%mylev(levnum)%dt=dt1
call jpdecode(myrec(22:39),anuc%A,anuc%mylev(levnum)%js,anuc%mylev(levnum)%jp,anuc%mylev(levnum)%jmodi,anuc%mylev(levnum)%nospin)
anuc%mylev(levnum)%nog=0
do i=1,anuc%nobands
if(myrec(3:3).eq.anuc%bands(i)) then
anuc%mylev(levnum)%band=myrec(3:3)
anuc%mylev(levnum)%sdband=anuc%sdbands(i)
endif
enddo

end
!********************************************
!Store xref record
subroutine myxref(myrec,anuc)
include 'declar.inc'
nxref=nxref+1
anuc%xreflines(nxref)=myrec
end
!********************************************
!Decode level xref codes
subroutine mylevelxref(myrec,anuc)
integer ibegin,iend
include 'declar.inc'

myrec(10:80)=adjustl(myrec(10:80))
ibegin=index(myrec,'XREF')+4
if(ibegin.gt.0.and.ibegin.le.80) then
	if(ibegin+59.gt.80) then
	iend=80
	else
	iend=ibegin+59
	endif
anuc%mylev(levnum)%xrefs=myrec(ibegin:iend)
else
write(*,*) 'bad XREF record at A,Z',anuc%A,anuc%Z
write(*,*) myrec
endif
end
subroutine readparams(parm,nparm)
real dummy
integer idummy,i
include 'declar.inc'
i=1
2 read(9,'(4i4,6(1x,f9.5),2i4)',end=1) idummy,parm(i)%a,parm(i)%z,idummy,parm(i)%t,parm(i)%dt,parm(i)%u0,parm(i)%du0,dummy,parm(i)%chi,parm(i)%nmax,parm(i)%nmin
i=i+1
goto 2
1 continue
nparm=i-1
close(5)
end
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!fit U0 for nuclei where T param is not given in Fit
subroutine fitu0(anuc,tfitted,td,nt)
integer nt,i,nmaxold,nmax,nmin,midle,a
real*4 s1,s2,s3,s4,u0,du0,lgs1,chiold,chi
real*4 tfitted(270),td(270),e(1000)
logical flag,lx
include 'declar.inc'
logical even
external even
nmax=anuc%nlev;nmaxold=nmax;chi=0.0
do i=2,nmax
lx=anuc%mylev(i)%sdband.eq.'y'
lx=lx.or.(anuc%mylev(i)%uncertain.ne.'    '.and.anuc%mylev(i-1)%e.gt.1000.).and.anuc%mylev(i)%e.eq.0.0
lx=lx.or.(anuc%mylev(i-1)%e.gt.anuc%mylev(i)%e)
if(lx) then
 nmax=i-1;nmaxold=nmax;goto 22
endif
e(i)=anuc%mylev(i)%e*0.001
if(i.gt.1.and.e(i).eq.0.0) then
e(i)=0.001
endif
enddo
22 continue
a=anuc%a
if(nmax.ge.20.and.(a.ge.9.and.a.le.250)) then
	nmin=7
	if((.not.even(anuc%z)).and.(.not.even(a))) nmin=14
else
		u0=0.0;du0=1.0
		nmax=1;nmin=1;chi=0.0
anuc%nmax=nmax
if(a.gt.0) then
anuc%nmax=nmax;anuc%nmin=nmin;anuc%umax=anuc%mylev(nmax)%e
anuc%u0=u0;anuc%du0=du0
endif
return
endif
chi=0.0;chiold=0.0
1 flag=.true.
s1=0.;s2=0.;s3=0.;s4=0.;nmaxold=nmax
	do i=nmin,nmax
		s1=s1+1.;lgs1=log(float(i))
		s2=s2+tfitted(a)*lgs1/e(i)
		s3=s3+1./e(i)
		s4=s4+lgs1/e(i)
	enddo
	u0=(s1-s2)/s3;du0=abs(s4/s3)*td(a)
	s2=0.0;chi=0.0
	do i=nmin,nmax
	s2=s2+1.
	chi=chi+(log(float(i))-(e(i)-u0)/tfitted(a))**2/e(i)
!	write(4,*) i,chiold
	enddo
	chi=sqrt(chi/(s2-1.0))
	s2=float(nmax);s3=0.0;s4=-1.0
	do i=nmax,nmin,-1
	s4=s4+1.
		s1=log(s2-s4)-(e(i)-u0)/tfitted(a)
		if(s1.gt.0.0.and.flag) then
			nmaxold=nmax
			nmax=i;flag=.false.
			if(nmin.ge.nmax)  then
			nmax=nmaxold
			goto 2
			endif
		endif
	enddo
	if(nmaxold.le.nmax) then
	write(*,'(2i4,4(1x,f9.5),2i4,2(1x,1pe10.3))') &
	a,anuc%z,tfitted(a),td(a),u0,du0,nmax,nmaxold,chi,chiold
	nmax=nmaxold
	goto 2
	else
	write(*,'(2i4,4(1x,f9.5),3i4,2(1x,1pe10.3))') &
	a,anuc%z,tfitted(a),td(a),u0,du0,nmax,nmin,nmaxold,chi,chiold
	chiold=chi
	goto 1
	endif
2 continue
anuc%nmax=nmax;anuc%nmin=nmin;anuc%umax=anuc%mylev(nmax)%e;anuc%chi=chi
anuc%u0=u0;anuc%du0=du0
end
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
subroutine spinestimate(anuc,parm,nparm,tfitted,td,nt)
USE DFLIB 
integer nt,nmin
real*4 tfitted(270),td(270),u0,du0,chi
real spmin,spmax,fact,sigl,prob(5),w,w1,tmpsp,w2,tmpsp1,wp
integer i,m,final,k,j,counter,myk,nc
logical parexist
character el*2
include 'declar.inc'
sigl=0;chi=0.0
do i=1,anuc%nlev
	if(anuc%mylev(i)%nospin.eq.1) then
		if(anuc%mylev(i)%js(1).ne.-1.0) then
		anuc%mylev(i)%jsmy=anuc%mylev(i)%js(1);anuc%mylev(i)%jpmy=anuc%mylev(i)%jp(1)
		anuc%mylev(i)%jpestimate='u' ! Unique spin
		else
		anuc%mylev(i)%jpmy=anuc%mylev(i)%jp(1)
		endif
	else
	anuc%mylev(i)%jsmy=-1.;anuc%mylev(i)%jpmy=0.
	anuc%mylev(i)%jpestimate=' '
	endif
enddo

nc=0;anuc%ncrelaxed=0
!determine spin cutoff for this case
	do i=1,anuc%nlev
	if(anuc%mylev(i)%nospin.eq.1.and.index(anuc%mylev(i)%jptext,'(').eq.0) then
	nc=nc+1
	else
	goto 4
	endif
	enddo
4 anuc%nc=nc
	do i=1,anuc%nlev
	if(anuc%mylev(i)%nospin.eq.1) then
	anuc%ncrelaxed=anuc%ncrelaxed+1
	else
	goto 44
	endif
	enddo
44 continue
if(anuc%nc.gt.0) then
anuc%uc=anuc%mylev(anuc%nc)%e
else
if(anuc%nlev.gt.0) then
anuc%uc=0.0;anuc%nc=1
else
anuc%uc=0.0;anuc%nc=0
endif
endif
parexist=.false.
do j=1,nparm
	if(anuc%a.eq.parm(j)%a.and.anuc%z.eq.parm(j)%z) then
	anuc%nmax=parm(j)%nmax
	anuc%nmin=parm(j)%nmin
	anuc%umax=anuc%mylev(anuc%nmax)%e
	anuc%u0=parm(j)%u0
	anuc%du0=parm(j)%du0
	anuc%chi=parm(j)%chi
	parexist=.true.
	endif
enddo
!If No of uncertain levels is greater then 2 modify data
if(anuc%nouncertain.gt.2.or.anuc%nlev.lt.20) then
anuc%u0=0.0
anuc%du0=0.0
anuc%nmax=1
anuc%nmin=1
anuc%umax=0.0
anuc%chi=0.0
goto 3
endif
if(.not.parexist) then
call fitu0(anuc,tfitted,td,nt)
endif
!First estimate spin for levels, which decay to known spin levels by gamma-ray and spin was not given by evaluators
j=0
	do i=1,anuc%nlev
		j=j+anuc%mylev(i)%nog
		if(anuc%mylev(i)%nospin.eq.0.and.anuc%mylev(i)%nog.gt.0) then
		spmin=200.;spmax=-1.
		do m=j-anuc%mylev(i)%nog+1,j
		final=anuc%mygam(m)%final
			if(anuc%mylev(final)%nospin.gt.0) then
				do k=1,anuc%mylev(final)%nospin
				spmin=min(spmin,anuc%mylev(final)%js(k));spmax=max(spmax,spmin,anuc%mylev(final)%js(k))
				enddo
			endif
		enddo
		if(spmin.ne.-1.0.and.spmax.ne.200.0.and.i.le.anuc%nmax) then
			anuc%mylev(i)%jpestimate='g' !estimate from gammas
			call spgenerate(anuc,spmin,spmax,i)
		endif
		endif
	enddo
!creating spin distribution for a nucleus upto the level no. parm.nmax
!Determine spincutoff parameter using estimate of EMPIRE code
	counter=0
	sigl=0.
	do i=1,anuc%nmax
		if(anuc%mylev(i)%nospin.gt.0.and.anuc%mylev(i)%js(1).ne.-1.0) then
		counter=counter+1
			fact=1./float(anuc%mylev(i)%nospin)
			do k=1,anuc%mylev(i)%nospin
			sigl=sigl+fact*(anuc%mylev(i)%js(k)+0.5)**2
			enddo
		endif
!		if(anuc%a.eq.9.and.anuc%z.eq.4) write(8,*) counter,sigl,fact
	enddo
!Can not generate spin
	if(counter.lt.10) then
	do i=1,anuc%nlev
		anuc%mylev(i)%jpestimate=' '
	enddo
	goto 3
	endif
	sigl=(sigl/float(counter)-0.25)*0.5
	anuc%spcutoff2=sigl
!		if(anuc%a.eq.9.and.anuc%z.eq.4) write(8,*) counter,sigl
!generate unique spin and parity
	do i=1,anuc%nmax
 			call random(w);call random(wp)
			w1=0.
		if(anuc%mylev(i)%nospin.gt.1) then
			do k=1,anuc%mylev(i)%nospin
			tmpsp1=anuc%mylev(i)%js(k)
			prob(k)=spind(tmpsp1,sigl)
			w1=w1+prob(k)
			enddo
			do k=1,anuc%mylev(i)%nospin
			prob(k)=prob(k)/w1
			enddo
			w1=0.
			do k=1,anuc%mylev(i)%nospin
				w1=w1+prob(k)
				if(w1-w.gt.0.0) then 
				myk=k
				goto 1
				endif
			enddo
		1	continue
! Set uniqe spin
			anuc%mylev(i)%jsmy=anuc%mylev(i)%js(myk)
			!Set parity
				if(anuc%mylev(i)%jp(myk).eq.0.0) then
					anuc%mylev(i)%jpmy=pmy(wp)
				else
					anuc%mylev(i)%jpmy=anuc%mylev(i)%jp(myk)
				endif
			if(anuc%mylev(i)%jpestimate.ne.'g') anuc%mylev(i)%jpestimate='c' ! Choosen spin
			if(nc.eq.0) nc=i-1
!write(*,*) anuc%mylev(i)%jpestimate
		else !nospin>1 upto here
				w1=0.
				do k=0,2.0*sqrt(sigl)
				tmpsp=k+anuc%evenodd
				w1=w1+spind(tmpsp,sigl)
				enddo
				w2=0.0
			if(anuc%mylev(i)%nospin.eq.1) then
				if(anuc%mylev(i)%js(1).ne.-1.0) then
				anuc%mylev(i)%jsmy=anuc%mylev(i)%js(1)
				else
				do k=0,2.0*sqrt(sigl)
				tmpsp=k+anuc%evenodd
				w2=w2+spind(tmpsp,sigl)/w1
				if(w2-w.gt.0.0) then
				anuc%mylev(i)%jsmy=tmpsp
				anuc%mylev(i)%jpmy=pmy(wp)
				if(nc.eq.0) nc=i-1
				goto 22
				endif
				enddo
			22	continue
				endif
				if(anuc%mylev(i)%jp(1).eq.0.0) then
					anuc%mylev(i)%jpmy=pmy(wp)
				else
					anuc%mylev(i)%jpmy=anuc%mylev(i)%jp(1)
				endif
			else !nospin=0
				do k=0,2.0*sqrt(sigl)
				tmpsp=k+anuc%evenodd
				w2=w2+spind(tmpsp,sigl)/w1
				if(w2-w.gt.0.0) then
				anuc%mylev(i)%jsmy=tmpsp
				anuc%mylev(i)%jpmy=pmy(wp)
				if(nc.eq.0) nc=i-1
				goto 2
				endif
				enddo
			2	continue
			endif
			if(anuc%mylev(i)%jpestimate.eq.' ') anuc%mylev(i)%jpestimate='n'
		endif
	enddo
3 continue
!get element name
call zname(el,anuc%z,2)
if(anuc%z.eq.0) el='n '
if(.not.parexist) then	
	if(anuc%chi.le.0.0) then
	write(8,'(2i4,1x,a2,4(1x,f9.5),4i4,1x,f8.5,1x,f8.5,15x,i4,a4,a7,1x,f6.3)') &
	anuc%z,anuc%a,el,tfitted(anuc%a),td(anuc%a),anuc%u0,anuc%du0,anuc%nlev,anuc%nmax,anuc%nmin,anuc%nc,anuc%umax*0.001,anuc%uc*0.001,anuc%nouncertain,anuc%unclevnum,anuc%unceremin,sqrt(anuc%spcutoff2)
	else
		if(anuc%chi.gt.0.0.and.anuc%chi.le.0.05) then
		write(8,'(2i4,1x,a2,4(1x,f9.5),4i4,1x,f8.5,1x,f8.5,(1x,1pe10.3),4x,i4,a4,a7,1x,0pf6.3)') &
		anuc%z,anuc%a,el,tfitted(anuc%a),td(anuc%a),anuc%u0,anuc%du0,anuc%nlev,anuc%nmax,anuc%nmin,anuc%nc,anuc%umax*0.001,anuc%uc*0.001,anuc%chi,anuc%nouncertain,anuc%unclevnum,anuc%unceremin,sqrt(anuc%spcutoff2)
		else
		write(8,'(2i4,1x,a2,4(1x,f9.5),4i4,1x,f8.5,1x,f8.5,(1x,1pe10.3),3x,A1,i4,a4,a7,1x,0pf6.3)') &
		anuc%z,anuc%a,el,tfitted(anuc%a),td(anuc%a),anuc%u0,anuc%du0,anuc%nlev,anuc%nmax,anuc%nmin,anuc%nc,anuc%umax*0.001,anuc%uc*0.001,anuc%chi,'F',anuc%nouncertain,anuc%unclevnum,anuc%unceremin,sqrt(anuc%spcutoff2)
		endif
	endif
else
	if(anuc%chi.gt.0.0.and.anuc%chi.le.0.05) then
	write(8,'(2i4,1x,a2,4(1x,f9.5),4i4,1x,f8.5,1x,f8.5,(1x,1pe10.3),1x,A1,2x,i4,a4,a7,1x,0pf6.3)') &
	anuc%z,anuc%a,el,tfitted(anuc%a),td(anuc%a),anuc%u0,anuc%du0,anuc%nlev,anuc%nmax,anuc%nmin,anuc%nc,anuc%umax*0.001,anuc%uc*0.001,anuc%chi,'*',anuc%nouncertain,anuc%unclevnum,anuc%unceremin,sqrt(anuc%spcutoff2)
	else
	write(8,'(2i4,1x,a2,4(1x,f9.5),4i4,1x,f8.5,1x,f8.5,(1x,1pe10.3),1x,A3,i4,a4,a7,1x,0pf6.3)') &
	anuc%z,anuc%a,el,tfitted(anuc%a),td(anuc%a),anuc%u0,anuc%du0,anuc%nlev,anuc%nmax,anuc%nmin,anuc%nc,anuc%umax*0.001,anuc%uc*0.001,anuc%chi,'* F',anuc%nouncertain,anuc%unclevnum,anuc%unceremin,sqrt(anuc%spcutoff2)
	endif

endif
end
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
subroutine spgenerate(anuc,spmin,spmax,i)
integer i,m,final
real spmin,spmax,ds	,k
include 'declar.inc'
if(spmax-spmin.ge.4.) then
ds=spmax-spmin;ds=int(ds+0.51)
anuc%mylev(i)%nospin=1;anuc%mylev(i)%js(1)=spmin+ds
endif
if(spmax-spmin.eq.3.) then
anuc%mylev(i)%nospin=2;anuc%mylev(i)%js(1)=spmin+1.;anuc%mylev(i)%js(2)=spmin+2.
endif
if(spmax-spmin.eq.2.) then
anuc%mylev(i)%nospin=3;anuc%mylev(i)%js(1)=spmin;anuc%mylev(i)%js(2)=spmin+1.
anuc%mylev(i)%js(3)=spmin+2.
endif
if(spmax-spmin.eq.1.) then
m=0
do k=spmin-1.,spmin+2.
if(k.ge.0.and.(.not.(k.eq.0.and.spmin.eq.0))) then
m=m+1
anuc%mylev(i)%js(m)=k
anuc%mylev(i)%nospin=m
endif
enddo
endif
if(spmax-spmin.eq.0.) then
m=0
do k=spmin-2.,spmin+2.
if(k.ge.0.and.(.not.(k.eq.0.and.spmin.eq.0))) then
m=m+1
anuc%mylev(i)%js(m)=k
anuc%mylev(i)%nospin=m
endif
enddo
endif

end
real function spind(x,s)
real x,s,w
if(s.eq.0.) then
spind=0.
return
endif
w=-(x+0.5)**2/(2.0*s)+1.0/(8.0*s)
if(abs(w).lt.20) then
spind=(2.0*x+1.0)*exp(w)/(2.0*s)
else
spind=0.
endif
end
real function pmy(x)
real x
pmy=1.0
if(x.lt.0.5) pmy=-1.0
end
!Decode the decay modes of a level and their percentes
subroutine mydmode(myrec,anuc)
real*8 x(3)
integer i,m,k,txtl(16),pr(16),pend(16),length,nomode,nonspace,beg
character txt(16)*8,text*8,w*128,prefix*2
include 'declar.inc'
!Others like 20NE ... is neglected due to their small value of percentages
data txt/'%P','%N','%G','%EC+%B+','%EC','%A','%B-','%IT','%SF','%3HE','%ECP','%ECA', &
'%B+P','%B+2P','%B-N','%B-2N'/
data txtl/2,2,2,7,3,2,3,3,3,4,4,4,4,5,4,5/
nomode=1
length=len(myrec)
do i=length,1,-1
if(myrec(i:i).ne.' ') then
nonspace=i
goto 1
endif
enddo
1 do i=1,16
text=txt(i);pr(i)=0;pend(i)=0
pr(i)=index(myrec(1:nonspace),text(1:txtl(i)))
if (pr(i).gt.0) then
pr(i)=pr(i)+txtl(i)
if(scan(myrec(pr(i):pr(i)),'=<> ').eq.0) then
pr(i)=0
endif
endif
if (pr(i).gt.0) then
	pr(i)=pr(i)
	beg=pr(i)
	pend(i)=scan(myrec(beg:nonspace),'$(%')
	if(pend(i).gt.0) then
	pend(i)=beg+pend(i)-2
	beg=pend(i)
	else
	pend(i)=nonspace
	endif
	w=myrec(pr(i):pend(i))
endif
enddo
k=0
do i=1,16
if(pr(i).gt.0) then
k=k+1
call decode_decaymode_numbers(myrec(pr(i):pend(i)),x,prefix)
!write(4,*) prefix,x
anuc%mylev(levnum)%dpercent(k)=x(1)
anuc%mylev(levnum)%dmodes(k)=txt(i)
anuc%mylev(levnum)%dpercentu(k)=x(2)
anuc%mylev(levnum)%pfix(k)=prefix
anuc%mylev(levnum)%nobr=k
endif
enddo
end
!***************************************************
subroutine decode_decaymode_numbers(str1,x,prefix)
real*8 x(3)
character prefix*2,str1*(*),str2*30,mx*10,nx*10
integer legth,i,l1,space,nonspace
length=len(str1)
write(str2,*) str1(1:length)
! Find prfixes
!=
l1=index(str2,'=')
if(l1.gt.0) then
prefix='='
str2(l1:l1)=' '
endif
!<
l1=index(str2,'<')
if(l1.gt.0) then
prefix='<'
str2(l1:l1)=' '
endif
!>
l1=index(str2,'>')
if(l1.gt.0) then
prefix='>'
str2(l1:l1)=' '
endif
!LT
l1=index(str2,'LT')
if(l1.gt.0) then
prefix='LT'
str2(l1:l1+1)='  '
endif
!AP
l1=index(str2,'AP')
if(l1.gt.0) then
prefix='AP'
str2(l1:l1+1)='  '
endif
!GT
l1=index(str2,'GT')
if(l1.gt.0) then
prefix='LT'
str2(l1:l1+1)='  '
endif
!SY from systematics
l1=index(str2,'SY')
if(l1.gt.0) then
prefix='SY'
str2(l1:l1+1)='  '
endif
!LT
l1=index(str2,'LT')
if(l1.gt.0) then
prefix='LT'
str2(l1:l1+1)='  '
endif
!LE
l1=index(str2,'LE')
if(l1.gt.0) then
prefix='LE'
str2(l1:l1+1)='  '
endif
!GE
l1=index(str2,'GE')
if(l1.gt.0) then
prefix='GE'
str2(l1:l1+1)='  '
endif
!?
l1=index(str2,'?')
if(l1.gt.0) then
prefix='? '
str2(l1:l1+1)=' '
endif
x=0.
str2=adjustl(str2)
length=len(str2)
do i=length,1,-1
if(str2(i:i).ne.' ') then
nonspace=i
goto 1
endif
enddo
1 continue
do i=1,length
if(str2(i:i).eq.' ') then
space=i
goto 2
endif
enddo
2 continue
if(space.gt.nonspace) nonspace=space
call fend(str2(1:space),str2(space:nonspace),x,mx,nx)
i=0
end
logical function even(i)
integer i
real*4 x
x=i
even=.false.
if(x/2.-float(int(x/2.+.1)).lt.0.1)  even=.true.
end
