!This commented section is for testin internal conversion (icc) interpolation
!real(8) eg,dmix,icc
!logical firstentry
!CHARACTER*10 STRMUL
!integer z
!z=62
!firstentry=.true.
!eg=25.71;dmix=0.0;strmul='E1'
!call mixedalpha(z,eg,dmix,strmul,firstentry,icc)
!write(*,*) 'icc= ',icc
!firstentry=.false.
!eg=4.821;dmix=0.024;strmul='M1+E2'
!call mixedalpha(z,eg,dmix,strmul,firstentry,icc)
!write(*,*) 'icc= ',icc
!eg=35.13;dmix=0.5;strmul='M1+E2'
!call mixedalpha(z,eg,dmix,strmul,firstentry,icc)
!write(*,*) 'icc= ',icc
!stop
!end
!****************************************************************
subroutine mixedalpha(z,eg,dmix,strmul,firstentry,icc)
real(8)   ,static :: alpha(23, 8, 10)                                        
real(8)   ,static :: etab(23, 10),lnetab(23, 10) 
real(8)   ,static :: ahypermat(24,24,10),bhypermat(24,23,10)
real(8) seg(23),adjust(2),dmix,eg,logeg,egpower(2),alphatot,iccshell(2,10),w,xx,icc                                             
integer ,static :: netab(10),zoftab
integer j,n,mpol(2),mtemp,i,k,l,m,z
logical lz,firstentry,outoftable
CHARACTER*10 STRMUL
icc=0.0
lz=(z.ge.14.and.z.le.103).or.z.eq.10.or.z.eq.6.or.z.eq.3
if(lz) then
if(eg.le.0.0) then
eg=eg
icc=-1.0
return
else
logeg=dlog(eg)
endif
outoftable=.false.
if(firstentry) then
zoftab=z
!Get data from tables                                                 
call get_alpha(z,alpha,etab,netab)
!Transform Alpha values suitable for interpolation
! alpha=log(alpha*Egamma^(2*multipol+1)); lnetab=log(etab) This differs from the original energy
! trasformation, but much simpler. I do not see reason for more complicate tratment.
! Checked by plotting critical curves. around z=55, L2 subshell.
!
do i=1,10
	if(netab(i).gt.0) then
	do k=1,netab(i)
		do l=1,8
		m=l-((l-1)/4)*4
		w= alpha(k,l,i)*etab(k,i)**(2*m+1)
		alpha(k,l,i)=dlog(w)
		enddo
		lnetab(k,i)=dlog(etab(k,i))
	enddo
	endif
enddo
!set up 10 cardinal spline systems for the 10 different subshells
! The interpolation is very simple for these kind of cubic splines
call cardinals(z,lnetab,netab,ahypermat,bhypermat)
!Check values of Cardinal splines
!do i=1,10
!n=netab(i)
!do k=1,n
!xx=lnetab(k,i)
!do l=1,n
!seg(l)= CARD(XX,l,lnetab(1,i),n,ahypermat(1,1,i),bhypermat(1,1,i))
!enddo
!write(*,'(23f5.2)') (seg(j),j=1,n)
!enddo
!read(*,*)
!write(*,*)
!enddo
!Calculate mixed conversion coeff
endif
if(zoftab.ne.z) then
write(*,*) 'Z has been changed but firstentry is still false'
stop
endif
	icc=0.0
             adjust(1)=1.                                           
             adjust(2)=1.
			 mpol(1)=0;mpol(2)=0                                            
             K = 1                                                      
             IF (INDEX(STRMUL, 'M4') .NE. 0) THEN                       
                  adjust(K)=0.975                                       
                 MPOL(K) = 8                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'M3') .NE. 0) THEN                       
                  adjust(K)=0.975                                       
                 MPOL(K) = 7                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'M2') .NE. 0) THEN                       
                 MPOL(K) = 6                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'M1') .NE. 0) THEN                       
                 MPOL(K) = 5                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'E4') .NE. 0) THEN                       
                  adjust(K)=0.975                                       
                 MPOL(K) = 4                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'E3') .NE. 0) THEN                       
                  adjust(K)=0.975                                       
                 MPOL(K) = 3                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'E2') .NE. 0) THEN                       
                 MPOL(K) = 2                                            
                 K = 2                                                  
             ENDIF                                                      
             IF (INDEX(STRMUL, 'E1') .NE. 0) THEN                       
                 MPOL(K) = 1                                            
             ENDIF                                                      
!C                                                                      
!C-MPOL(1) HAS M OR E ORDER; MPOL(2) HAS E OR NONE                      
!C-IF ORDER 1 HIGHER THAN ORDER 2, SWAP MPOL                   
!C                                                                      
             IF (MPOL(2) .NE. 0) THEN                                   
                IF ((MPOL(1) - 4) .GT. MPOL(2)) THEN                    
                    MTEMP = MPOL(1)                                     
                    MPOL(1) = MPOL(2)                                   
                    MPOL(2) = MTEMP
					w=adjust(1)
					adjust(1)=adjust(2)
					adjust(2)=w                                     
                ENDIF                                                   
             ENDIF
!Calculat icc from subshell values using cardinal spline interpolation                                                      
m=mpol(1)-((mpol(1)-1)/4)*4
egpower(1)=(eg)**(2*m+1)
m=mpol(2)-((mpol(2)-1)/4)*4
egpower(2)=(eg)**(2*m+1)
do i=1,10
	n=netab(i)
if(etab(1,i).le.eg.and.etab(n,i).ge.eg) then
	do k=1,2
	iccshell(i,k)=0.0
		if(mpol(k).ne.0) then
			do l=1,netab(i)
			w=CARD(logeg,l,lnetab(1,i),n,ahypermat(1,1,i),bhypermat(1,1,i))
			iccshell(i,k)=iccshell(i,k)+alpha(l,mpol(k),i)*w
			enddo
		endif
	enddo
	if(mpol(2).ne.0) then
		if(iccshell(i,1).ne.0.0) icc=icc+adjust(1)*exp(iccshell(i,1))/egpower(1)
		if(iccshell(i,2).ne.0.0) icc=icc+adjust(2)*exp(iccshell(i,2))/egpower(2)*dmix**2
	else
!Pure miltipolarity
		if(iccshell(i,1).ne.0.0) icc=icc+adjust(1)*exp(iccshell(i,1))/egpower(1)
	endif
endif
enddo
	if(mpol(2).ne.0) then
	icc=icc/(1.0+dmix**2)
	endif
else
icc=0.0
endif
return
end
!****************************************************************************
subroutine get_alpha(z,alpha,etab,netab)
real(8)    alpha(23, 8, 10)                                        
real(8)    etab(23,10)                                              
integer netab(10)                                                 
real    data1(9)
integer index,tblkey,ie,z,ztab
CHARACTER*2 SHTAB,SHOLD                                                          
!c open icc index table
open(unit=22, access='direct', form='unformatted',readonly,recl=1,file='iccndx.dat',status='old')                                                 
!c open icc table
open(unit=21, access='direct', form='unformatted',readonly,recl=11,file='icctbl.dat',status='old')                                                 
do j = 1, 10												  
netab(j) = 0												  
	do i = 1, 23											  
	etab(i, j) = 0.0										  
		do k = 1, 8 										  
		alpha( i, k, j) = 0.0								  
		enddo
	enddo
enddo													  
!c get the charge nuber z
!c                                                                       
!c-table range is z = 2 to z = 103                                       
!c                                                                       
if (z .gt. 103) write(*,*) 'z is out of range z=',z                                 
if (z .lt. 14) then                                               
if(z .ne. 10 .or. z.ne.6 .or. z.ne.3) write(*,*) 'z is out of range z=',z           
endif                                                             
      read(22,rec=z) tblkey                                             
      if (tblkey .eq. 0) Write(*,*) 'There in no table key for this Z'                                   
      ie = 0                                                            
!c                                                                       
!c-read data from tables, ordered by z, subshell, and multipolarity      
!c-data holds table gamma energy and icc values for the current subshel  
!c  read data logic below changed to simplify (9/25/90) elim assign etc  
!c                                                                       
  250 read(21,rec=tblkey) ztab, shtab, data1
!	write(*,*) ztab, shtab, data1                             
      tblkey=tblkey+1                                                   
      if (ztab .eq. z) then                                             
         if (shold .ne. shtab) then                                     
            shold = shtab                                               
            if (ie .ne. 0) netab(ish) = ie                              
            ie = 0                                                      
            if(shtab(1:1).eq.'K') then                                  
                ish = 1                                                 
            else if(shtab(1:1).eq.'L') then                             
                read(shtab(2:2),'(i1)') ishell                          
                ish = ishell + 1                                        
            else if(shtab(1:1).eq.'M') then                             
                read(shtab(2:2),'(i1)') ishell                          
                ish = ishell + 4                                        
            else if(shtab(1:1).eq.'N') then                             
                ish=10                                                  
            else                                                        
            endif                                                       
         endif                                                          
!c                                                                       
         ie = ie + 1
!c-etab is table gamma energy, alpha is tabular icc for the 8 multipo 
!c ie=index of gamma energy; ish index of shell; i index of multipolarity  
         etab(ie, ish) = data1(1)                                        
         do i = 1, 8                                                
             alpha(ie, i, ish) = data1(i + 1)                           
		 enddo                                                          
!c                                                                       
!c-exit from file read loop when table values for given z exhausted      
!c                                                                       
         if (tblkey .le. 13004) goto 250                                                                                                      
      endif                                                             
      if (ie .ne. 0) netab(ish) = ie
	  do i=1,10
!	  write(*,*) netab(i),i
	  enddo
!c end of icc data read
close(22); close(23)
return
end                                 
